;time-stamp: <02/04/21 01:50:52 kawasan>
;Time-stamp: <02/05/11 23:06:16 kawasan>
;
;HAROIɂׂ܂킷
;ǉH̃vOłB
;I(TIME_MINɂČŒ)Ƀ|[g(Port-ABit2)hCu邾B
;
;Device	16F84
;File	haro_max.asm
;OSC	RC ( R = 4.7K, C = 100p : About 1MHz)
;WDT	Off
;PuT	On
;CP	Off
;Code	001B ( FreePiceeɂďގɎgRtBM[VEq[Y̒l )
;	́AConfiguration̏ŃR[hĂ܂B
;
;ASM	DebianpicasmpbP[WɂăAZuĂB(UnixėpH)
;
;******************************************************
;	Include
;******************************************************
	include "pic16c84.inc"
;
;
;******************************************************
;	Configuration
;******************************************************
	config CP=off, PWRT=on, WDT=off, OSC=RC
;
;
;******************************************************
;       Define
;******************************************************
O_LED		equ	PORTA		; debug-LED( 0/1 = _/ )
OB_LED		equ	( 3 )		;
O_MIC		equ	PORTA		; Mic-Drive
OB_MIC		equ	( 2 )		;
;
; X = 1MHz, vXP[Ȃ, TMR0 = 256
; ( X / 4 ) / 256 = About 1000Hz  1msŊ荞ݔ
TIME_INT_BASE	equ	( 10 * 1000 / 1000 )
TIME_10MS	equ	( 10 * 10 / TIME_INT_BASE )
TIME_500MS	equ	( 500 / 10 )	; TimeBase 10ms
TIME_1MIN	equ	( 60000 / 500 )	; TimeBase 500ms
;
TIME_MIN	equ	( 3 )		; TimeBase 1s
;
PULSE_TIME	equ	( 50 )		; PulseԐݒl(ms)
;
;******************************************************
;	Ram
;******************************************************
R_TOP		equ	( 00Ch )	;
R_SAVE_W	equ	( R_TOP + 0 )	; Stack W
R_SAVE_STATUS	equ	( R_TOP + 1 )	; Stack STATUS
R_TIME_CNT_MS	equ	( R_TOP + 2 )	; msJE^
R_TIME_10MS	equ	( R_TOP + 3 )	; 10msJE^(Base 1ms)
R_TIME_500MS	equ	( R_TOP + 4 )	; 500msJE^(Base 10msJE^)
R_TIME_1MIN	equ	( R_TOP + 5 )	; 1minJE^(Base 500msJE^)
R_TIME_MIN	equ	( R_TOP + 6 )	; minJE^(Base 1minJE^)
R_FLAGS00	equ	( R_TOP + 7 )	; etO
RB_DRV_EVEN	equ	( 0 )		; MICJnCxg
;
;
;******************************************************
;	Power On Reset
;******************************************************
	org	PIC84_RES
	goto	start			;
;
;
;******************************************************
;	Interrupt
;******************************************************
	org	PIC84_INT
	goto	int			;
;
;
;******************************************************
;	Start program
;******************************************************
start
	call	init_hard		;
	call	init_soft		;
;
	bsf	INTCON,GIE		; Ŝ̊荞݋
;
;
;******************************************************
;	Main program
;******************************************************
main
	btfss	R_FLAGS00,RB_DRV_EVEN	;
	goto	main_10			;
;
	bcf	R_FLAGS00,RB_DRV_EVEN	; Celar event
;
	call	access_mic		; MICuhCu
;
main_10
	goto	main			;
;
;
;******************************************************
;	Interrupt routine
;
;     mӁn
;	Push's & Pop's̏Bank0ł
;	OƂĂ܂
;******************************************************
int
; --- < WX^ޔ > ---
	movwf	R_SAVE_W		;
	swapf	STATUS,W		;
	movwf	R_SAVE_STATUS		; Push's
;
; --- [ A^C} ] ---
; --- < ^C}ċN > ---
;	movlw	TMR0_CNT		;
;	movwf	TMR0			; Set TMR0 cnt
	bcf	INTCON,T0IF		; Reset T0IF flag
;
;	< 1ms^C} >
	movf	R_TIME_CNT_MS,F		;
	btfss	STATUS,Z		; If R_TIME_CNT_MS = 0 the skip
	decf	R_TIME_CNT_MS,F		; msJE^ --
;
;	< 10ms^C} >
	decfsz	R_TIME_10MS,F		;
	goto	int_exit		;
;
	movlw	TIME_10MS		;
	movwf	R_TIME_10MS		;
;
;       < 500ms^C}[ >
	decfsz	R_TIME_500MS,F		;
	goto	int_exit		;
;
	movlw	TIME_500MS		;
	movwf	R_TIME_500MS		;
;
;	< DebugLed ] (500msɋN) >
	movlw	B'00001000'		;
	xorwf	O_LED,F			;
;
;	< 1min^C}[ (500msɋN) >
	decfsz	R_TIME_1MIN,F		;
	goto	int_exit		;
;
	movlw	TIME_1MIN		;
	movwf	R_TIME_1MIN		;
;
;	< min^C}[ (1minɋN) >
	decfsz	R_TIME_MIN,F		;
	goto	int_exit		;
;
	movlw	TIME_MIN		;
	movwf	R_TIME_MIN		;
	bsf	R_FLAGS00,RB_DRV_EVEN	;
;
; --- < WX^Ɗ̏I > ---
int_exit
	swapf	R_SAVE_STATUS,W		;
	movwf	STATUS			;
	swapf	R_SAVE_W,F		;
	swapf	R_SAVE_W,W		; Pop's
	retfie				;
;
;
;******************************************************
;	Initial routine ( Hard )
;******************************************************
init_hard
; --- < |[gݒ > ---
;	< |[go͒lݒ >
	bcf	STATUS,RP0		; Sel Bank0
	movlw	B'00000100'		;
	movwf	PORTA			; PortA Data = 0x04
	movlw	B'00000000'		;
	movwf	PORTB			; PortB Data = 0x00
;
;	< |[gI/Oݒ >
	bsf	STATUS,RP0		; Sel Bank1
;	bcf	STATUS,RP0		; Sel Bank0
	movlw	B'00000000'		;
;	movwf	TRISA			; RA[5-0] is "---o_oooo"
	TRIS	PORTA			;
	movlw	B'00000000'		;
;	movwf	TRISB			; RB[7-0] is "oooo_oooo"
	TRIS	PORTB			;
;
	movlw	B'10001111'		; /RBPU INTEDG RTS RTE PSA PS2 PS1 PS0
	OPTION				; 1     0      0   0   1   1   1   1
;	movwf	OPTION_REG		; 1     0      0   0   1   1   1   1
					; /RBPU :PortB pull-up = disable
					; INTEDG:Interrupt edge RB0/INT ~|_
					; T0CS  :TMR0 clock source CLOCKOUT
					; T0SE  :TMR0 clock edge RA4/T0CKI _|~ (dummy)
					; PSA   :Prescaler assignment bit = WDT
					; PS    :PRESCALER VALUE TMR0 RATE 1:128 (dummy)
;
;	< 荞ݐݒ >
	bcf	STATUS,RP0		; Sel Bank0
	clrf	TMR0			; Set TMR0 cnt
	bsf	INTCON,T0IE		; Enable TMR0 Int
	bcf	INTCON,T0IF		; Clear TMR0 OverFlow IntFlag
;
;	< |[go͒lݒ-2 >
	bsf	O_MIC,OB_MIC		; MIC-Dirve-Off
;
	return				;
;
;
;******************************************************
;	Initial routine ( Soft )
;******************************************************
init_soft
;	< 10ms-event^C} >
	movlw	TIME_10MS		;
	movwf	R_TIME_10MS		;
;
;	< 500ms-event^C} >
	movlw	TIME_500MS		;
	movwf	R_TIME_500MS		;
;
;	< 1min-event^C} >
	movlw	TIME_1MIN		;
	movwf	R_TIME_1MIN		;
;
;	< min^C} >
	movlw	TIME_MIN		;
	movwf	R_TIME_MIN		;
	bcf	R_FLAGS00,RB_DRV_EVEN	; Reset event
;
	return				;
;
;
;******************************************************
;	MIĈƂuhCu܂[`
;******************************************************
access_mic
	bcf	O_MIC,OB_MIC		; MIC-Dirve-On
;
	movlw	PULSE_TIME		;
	movwf	R_TIME_CNT_MS		; Set Timer
;
access_mic_50
	movf	R_TIME_CNT_MS,F		;
	btfss	STATUS,Z		; If R_TIME_CNT_MS = 0 then skip
;
	goto	access_mic_50		; ԑ҂邮
;
	bsf	O_MIC,OB_MIC		; MIC-Dirve-Off
	return				;
;
;
     END
